Unit ZF14R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTZF10_p;

procedure ZF14R(F :Func_F1; N :Integer; EPS :Real; NDIG :Integer;
                EPS1 :Real; EPS2 :Real; var ROOT :Array of Real;
                var ITMAX :Integer; var IERR :Integer);

implementation

procedure ZF14R(F :Func_F1; N :Integer; EPS :Real; NDIG :Integer;
                EPS1 :Real; EPS2 :Real; var ROOT :Array of Real;
                var ITMAX :Integer; var IERR :Integer);
var
J,I,IR,IC,NM1,NSIG :Integer;
AXI,AFXI,DI,DER,ERR,ERR1,FXI,FXIPHI,CRIT1,HI,XI,XIPI :Real;
const
P1 :Real = 0.1E0;
P001 :Real = 0.001E0;
ZERO :Real = 0.0E0;
ONE :Real = 1.0E0;
TEN :Real = 10.0E0;
SYS059 :Real = 1.7E38;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
NSIG := NDIG;
IERR := 0;
IR := 0;
if ( NDIG = 0 ) and ( EPS = 0.0 ) 
 then NSIG := 5;
CRIT1 := Power(TEN,-NSIG);
for I:=1 to N do
 begin
  IC := 1;
  XI := ROOT[I-1];
_1:
  AXI := Abs(XI);
  if ( I = 1 ) 
   then goto _3;
  NM1 := I-1;
  for J:=1 to NM1 do
   begin
    if ( Abs(XI-ROOT[J-1]) < Abs(EPS1) ) 
     then XI := XI+EPS2;
_2:
   end;
_3:
  FXI := F(XI);
  AFXI := Abs(FXI);
  if ( AFXI <= Abs(EPS) ) 
   then goto _6;
  DI := 10.E-9;
  if ( AXI >= P1 ) 
   then DI := P001*AXI;
  HI := EMin1(AFXI,DI);
  FXIPHI := F(XI+HI);
  DER := (FXIPHI-FXI)/HI;
  if ( DER = ZERO ) 
   then goto _5;
  XIPI := FXI/DER;
  XIPI := XI-XIPI;
  ERR := Abs(XIPI-XI);
  XI := XIPI;
  if ( AXI = ZERO ) 
   then AXI := ONE;
  ERR1 := ERR/AXI;
  if ( NSIG = 0 ) 
   then goto _4;
  if ( ERR1 <= CRIT1 ) 
   then goto _6;
_4:
  IC := IC+1;
  if ( IC <= ITMAX ) 
   then goto _1;
  ROOT[I-1] := SYS059;
  IR := IR+1;
  IERR := 1;
  goto _7;
_5:
  ROOT[I-1] := -SYS059;
  IR := IR+1;
  IERR := 2;
  goto _7;
_6:
  ROOT[I-1] := XI;
_7:
 end;
ITMAX := IC;
if ( IERR = 0 ) 
 then goto _9;
if ( IR <= 1 ) 
 then goto _8;
IERR := 3;
_8:
UTZF10(IERR,14);
_9:
end;

end.
